Package icyllis.modernui.fragment

# Class SharedElementCallback

java.lang.Object
icyllis.modernui.fragment.SharedElementCallback

public abstract class SharedElementCallback extends Object
Listener provided in `Fragment.setEnterSharedElementCallback(SharedElementCallback)` and `Fragment.setExitSharedElementCallback(SharedElementCallback)` to monitor the Fragment transitions. The events can be used to customize Fragment Transition behavior.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SharedElementCallback()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `onMapSharedElements(List<String> names, Map<String,View> sharedElements)`
  Lets the SharedElementCallback adjust the mapping of shared element names to Views.
  `void`
  `onRejectSharedElements(List<View> rejectedSharedElements)`
  Called after `onMapSharedElements(java.util.List, java.util.Map)` when transferring shared elements in.
  `void`
  `onSharedElementEnd(List<String> sharedElementNames, List<View> sharedElements, List<View> sharedElementSnapshots)`
  In Activity Transitions, onSharedElementEnd is called immediately before capturing the end of the shared element state on enter and reenter transitions and immediately before capturing the start of the shared element state for exit and return transitions.
  `void`
  `onSharedElementStart(List<String> sharedElementNames, List<View> sharedElements, List<View> sharedElementSnapshots)`
  In Activity Transitions, onSharedElementStart is called immediately before capturing the start of the shared element state on enter and reenter transitions and immediately before capturing the end of the shared element state for exit and return transitions.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### SharedElementCallback

    public SharedElementCallback()

- ## Method Details

  - ### onSharedElementStart

    public void onSharedElementStart(List<String> sharedElementNames, List<View> sharedElements, List<View> sharedElementSnapshots)
    In Activity Transitions, onSharedElementStart is called immediately before capturing the start of the shared element state on enter and reenter transitions and immediately before capturing the end of the shared element state for exit and return transitions.

    In Fragment Transitions, onSharedElementStart is called immediately before capturing the start state of all shared element transitions.

    This call can be used to adjust the transition start state by modifying the shared element Views. Note that no layout step will be executed between onSharedElementStart and the transition state capture.

    For Activity Transitions, any changes made in `onSharedElementEnd(List, List, List)` that are not updated during layout should be corrected in onSharedElementStart for exit and return transitions. For example, rotation or scale will not be affected by layout and if changed in `onSharedElementEnd(List, List, List)`, it will also have to be reset in onSharedElementStart again to correct the end state.

    Parameters:
      `sharedElementNames` - The names of the shared elements that were accepted into the View hierarchy.
      `sharedElements` - The shared elements that are part of the View hierarchy.
      `sharedElementSnapshots` - The Views containing snapshots of the shared element from the launching Window. These elements will not be part of the scene, but will be positioned relative to the Window decor View. This list is null for Fragment Transitions.

  - ### onSharedElementEnd

    public void onSharedElementEnd(List<String> sharedElementNames, List<View> sharedElements, List<View> sharedElementSnapshots)
    In Activity Transitions, onSharedElementEnd is called immediately before capturing the end of the shared element state on enter and reenter transitions and immediately before capturing the start of the shared element state for exit and return transitions.

    In Fragment Transitions, onSharedElementEnd is called immediately before capturing the end state of all shared element transitions.

    This call can be used to adjust the transition end state by modifying the shared element Views. Note that no layout step will be executed between onSharedElementEnd and the transition state capture.

    Any changes made in `onSharedElementStart(List, List, List)` that are not updated during layout should be corrected in onSharedElementEnd. For example, rotation or scale will not be affected by layout and if changed in `onSharedElementStart(List, List, List)`, it will also have to be reset in onSharedElementEnd again to correct the end state.

    Parameters:
      `sharedElementNames` - The names of the shared elements that were accepted into the View hierarchy.
      `sharedElements` - The shared elements that are part of the View hierarchy.
      `sharedElementSnapshots` - The Views containing snapshots of the shared element from the launching Window. These elements will not be part of the scene, but will be positioned relative to the Window decor View. This list will be null for Fragment Transitions.

  - ### onRejectSharedElements

    public void onRejectSharedElements(List<View> rejectedSharedElements)
    Called after `onMapSharedElements(java.util.List, java.util.Map)` when transferring shared elements in. Any shared elements that have no mapping will be in rejectedSharedElements. The elements remaining in rejectedSharedElements will be transitioned out of the Scene. If a View is removed from rejectedSharedElements, it must be handled by the `SharedElementListener`.

    Views in rejectedSharedElements will have their position and size set to the position of the calling shared element, relative to the Window decor View and contain snapshots of the View from the calling Activity or Fragment. This view may be safely added to the decor View's overlay to remain in position.

    This method is not called for Fragment Transitions. All rejected shared elements will be handled by the exit transition.

    Parameters:
      `rejectedSharedElements` - Views containing visual information of shared elements that are not part of the entering scene. These Views are positioned relative to the Window decor View. A View removed from this list will not be transitioned automatically.

  - ### onMapSharedElements

    public void onMapSharedElements(List<String> names, Map<String,View> sharedElements)
    Lets the SharedElementCallback adjust the mapping of shared element names to Views.
    Parameters:
      `names` - The names of all shared elements transferred from the calling Activity or Fragment in the order they were provided.
      `sharedElements` - The mapping of shared element names to Views. The best guess will be filled into sharedElements based on the transitionNames.